diff --git a/gnu/packages/freedesktop.scm b/gnu/packages/freedesktop.scm
index 2d12567a42..1c984ebca8 100644
--- a/gnu/packages/freedesktop.scm
+++ b/gnu/packages/freedesktop.scm
@@ -25,7 +25,7 @@
 ;;; Copyright © 2021 pineapples <guixuser6392@protonmail.com>
 ;;; Copyright © 2021 Sarah Morgensen <iskarian@mgsn.dev>
 ;;; Copyright © 2021 Robby Zambito <contact@robbyzambito.me>
-;;; Copyright © 2021 Maxime Devos <maximedevos@telenet.be>
+;;; Copyright © 2021, 2022 Maxime Devos <maximedevos@telenet.be>
 ;;; Copyright © 2021 John Kehayias <john.kehayias@protonmail.com>
 ;;; Copyright © 2021, 2021 Maxim Cournoyer <maxim.cournoyer@gmail.com>
 ;;; Copyright © 2022 Daniel Meißner <daniel.meissner-i4k@ruhr-uni-bochum.de>
@@ -76,6 +76,7 @@ (define-module (gnu packages freedesktop)
   #:use-module (gnu packages disk)
   #:use-module (gnu packages docbook)
   #:use-module (gnu packages documentation)
+  #:use-module (gnu packages file)
   #:use-module (gnu packages fontutils)
   #:use-module (gnu packages gawk)
   #:use-module (gnu packages gettext)
@@ -414,7 +415,15 @@ (define-public xdg-utils
      (list docbook-xsl docbook-xml-4.1.2 libxslt w3m xmlto))
     (inputs
      `(("awk" ,gawk)
+       ;; TODO(staging): Make this unconditional, to avoid canonical packages,
+       ;; see <https://lists.gnu.org/archive/html/guix-devel/2020-02/msg00148.html>.
+       ,@(if (%current-target-system)
+             `(("bash-minimal" ,bash-minimal)) ; for 'wrap-program'
+             '())
        ("coreutils" ,coreutils)
+       ,@(if (%current-target-system)
+             `(("file" ,file))
+             '())
        ("grep" ,grep)
        ("inetutils" ,inetutils) ; xdg-screensaver uses `hostname'
        ("perl-file-mimeinfo" ,perl-file-mimeinfo) ; for mimeopen fallback
@@ -428,19 +437,41 @@ (define-public xdg-utils
        #:phases
        (modify-phases %standard-phases
          (add-after 'unpack 'patch-hardcoded-paths
-           (lambda _
-             (substitute* "scripts/xdg-mime.in"
-               (("/usr/bin/file") (which "file")))
-             (substitute* "scripts/xdg-open.in"
-               (("/usr/bin/printf") (which "printf")))
-             #t))
+           ;; TODO(staging): make unconditional
+           (,@(if (%current-target-system)
+                 '(lambda* (#:key inputs #:allow-other-keys))
+                 '(lambda _))
+            (substitute* "scripts/xdg-mime.in"
+              (("/usr/bin/file")
+               (,@(if (%current-target-system)
+                      '(search-input-file inputs "bin/file")
+                      '(which "file")))))
+            (substitute* "scripts/xdg-open.in"
+              (("/usr/bin/printf")
+               (,@(if (%current-target-system)
+                      '(search-input-file inputs "bin/printf")
+                      '(which "printf")))))
+            #t))
          (add-before 'build 'locate-catalog-files
-           (lambda* (#:key inputs #:allow-other-keys)
-             (let ((xmldoc (string-append (assoc-ref inputs "docbook-xml")
-                                          "/xml/dtd/docbook"))
-                   (xsldoc (string-append (assoc-ref inputs "docbook-xsl")
-                                          "/xml/xsl/docbook-xsl-"
-                                          ,(package-version docbook-xsl))))
+           ;; TODO(staging): Make unconditional for simplicity.
+           (lambda* (#:key inputs ,@(if (%current-target-system)
+                                        '(native-inputs)
+                                        '()) #:allow-other-keys)
+             ;; TODO(staging): Make unconditional for simplicity and
+             ;; to avoid dependning on input labels.
+             (let ,(if (%current-target-system)
+                       `((native-inputs (or native-inputs inputs))
+                         (xmldoc (search-input-directory native-inputs
+                                                         "xml/dtd/docbook"))
+                         (xsldoc (search-input-directory
+                                  native-inputs
+                                  (string-append "xml/xsl/docbook-xsl-"
+                                                 ,(package-version docbook-xsl)))))
+                       `((xmldoc (string-append (assoc-ref inputs "docbook-xml")
+                                                "/xml/dtd/docbook"))
+                         (xsldoc (string-append (assoc-ref inputs "docbook-xsl")
+                                                "/xml/xsl/docbook-xsl-"
+                                                ,(package-version docbook-xsl)))))
                (for-each (lambda (file)
                            (substitute* file
                              (("http://.*/docbookx\\.dtd")
@@ -456,6 +487,7 @@ (define-public xdg-utils
                                  "/manpages/docbook.xsl man")))
                (setenv "STYLESHEET"
                        (string-append xsldoc "/html/docbook.xsl"))
+               ;; TODO(staging): Might as well remove the #t while we are at it.
                #t)))
          (add-after 'install 'wrap-executables
            (lambda* (#:key inputs outputs #:allow-other-keys)